{# {% extends 'base.html' %} #}

{% load static %}


<!----- CSS FILE ----->
<link rel="stylesheet" type="text/css" href="{% static 'myapp/style.css' %}">
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
<!----- SANKEY PLOT 
<script src="http://d3js.org/d3.v3.min.js"></script>
<script src="{% static 'myapp/sankey.js' %}"></script>
----->

<!----- START CONTENT ----->
<div class="container-fluid">
    <div class="row row-eq-height">
	<div class="col-sm-3">
	  <center>
	  <br>
	  <img src="{% static 'myapp/images/ectoplanner_logo.png' %}" alt="ectoplanner_logo" style="width:80px;height:80px;">
        <h1>Ectoplanner</h1>
		</center>
      </div>
      <div class="col-sm-2">
	  <br>
	  <button type="button" id="redbutton" onClick="submitTheForm()">Calculate</button>
	  </div>
      <div class="col-sm-5">
      {% if not processing_successful and not optimization_successful %}
      <div class="alert alert-danger">
        <strong>Error:</strong> Optimization process failed due to infeasibility error. Please check whether
        you allowed enough capacity in the balancing unit technologies to cover all thermal demands 
        of the district. Especially, check minimum and maximum capacity and checkboxes for all technologies. 
      </div>
      {% endif %}
      <div>
<p id="error_msg" style="color: red; font-weight: bold;"></p>
</div>
		</div>
      <div class="col-sm-1">
		<a href="{% url 'index' %}"><button type="button" id="greybutton">Main window</button></a>
      </div>
    </div>
  </div>
</div>


<div class="tab">
  <button class="tablinks" onclick="openTab(event, 'Weather')" id="defaultOpen">Location</button>
  <button class="tablinks" onclick="openTab(event, 'Demands')">Demands</button>
  <button class="tablinks" onclick="openTab(event, 'Tech_params')">Technical parameter</button>
  <button class="tablinks" onclick="openTab(event, 'Economic_params')">Economical parameters</button>
  {% if processing_successful %}
  <button class="tablinks" onclick="openTab(event, 'results_overview')" style="background-color:#ccffcc" id="defaultOpenResult">Result overview</button>
  <button class="tablinks" onclick="openTab(event, 'results_buildings')" style="background-color:#ccffcc">Buildings</button>
  <button class="tablinks" onclick="openTab(event, 'results_subsidies')" style="background-color:#ccffcc">Subsidy</button>
  {% endif %}  
  </div>

<form method="post" name="theForm" enctype="multipart/form-data">

<!----- WEATHER FILE ----->
<div id="Weather" class="tabcontent" style="background-color:#ffdddd">
  <h3>Location</h3>
  <select name="weather_location">
    <option value="berlin_germany">Berlin, Germany</option>    
	<option value="dusseldorf_germany">Düsseldorf, Germany</option>    
    <option value="frankfurt_germany">Frankfurt, Germany</option>
	<option value="hamburg_germany">Hamburg, Germany</option>
	<option value="koln_germany">Köln, Germany</option>
    <option value="munich_germany">München, Germany</option>
	<option value="stuttgart_germany">Stuttgart, Germany</option>

	<option value="goteburg_sweden">Göteburg, Sweden</option>  
	<option value="karlstad_sweden">Karlstad, Sweden</option>
    <option value="kiruna_sweden">Kiruna, Sweden</option>    
	<option value="ostersund_sweden">Östersund, Sweden</option>
    <option value="stockholm_sweden">Stockholm, Sweden</option>
  </select>
  
</div>

<!----- DEMAND TIME SERIES ----->
<div id="Demands" class="tabcontent" style="background-color:#ffdddd">
    {% csrf_token %}
	<h3>Building demands</h3>
	<div class="col-sm-12" id="building_div" style="border:1px solid #ccc">
		<h4>Building 1</h4>
		Heated/cooled floor area<input type="number" name="bldg_0_heated_area" value="1000" step=10 min="50"> m2<br>
		Specific heating demand <input type="number" name="bldg_0_spec_heat_dem" value="110" step=1 min="0"> kWh/m2<br>
		Specific cooling demand <input type="number" name="bldg_0_spec_cool_dem" value="30" step=1 min="0"> kWh/m2<br>
		Building type 
		<select name="bldg_0_type" selected="residential">
			<option value="residential">Residential</option>
			<option value="office">Office</option>
        </select> <br><br>
		<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#upload_time_series_0">Upload time series</button>
		<div id="upload_time_series_0" class="collapse">
			Heating demand (in kW) <input type="file" name="bldg_0_file_heat_dem">
			Cooling demand (in kW) <input type="file" name="bldg_0_file_cool_dem">
		<br><br>
		</div>
	</div>
	
	<button type="button" id="greybutton" onClick="addBuilding()">Add building</button>
</div>

<!----- TECHNOLOGY PARAMETER ----->
<div id="Tech_params" class="tabcontent" style="background-color:#ffdddd">
  <h3>Technical parameters</h3>
  <h4>General parameters</h4>
  
  <div class="container-fluid">
    <div class="row">
	  <div class="col-sm-3" style="border:1px solid #ccc">
        <h4>Building energy system</h4>
		Bivalent temperature<input type="number" name="bivalent_temp" value="3" step=1 min="-50" max="15">°C<br>
		<input type="checkbox" name="enable_free_cooling" value="True">Free cooling (instead of chillers)<br>
		<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#expand_costs_bldgs">More...</button>
		<div id="expand_costs_bldgs" class="collapse">
		<input type="checkbox" name="enable_use_carnot_cops" value="True" checked>Use Carnot efficiency<br>
		Carnot efficiency<input type="number" name="carnot_efficiency" value="0.5" step=0.01 min="0.2" max="1"><br>
		Supply temperature heating<input type="number" name="supply_temperature_heating" value="60" step=0.01 min="25" max="95"><br>
		Supply temperature cooling<input type="number" name="supply_temperature_cooling" value="8" step=0.01 min="2" max="25"><br>
		
		<input type="checkbox" name="enable_use_fix_cops" value="True">Use fix COPs<br>
		COP heat pumps<input type="number" name="COP_heat_pumps" value="4" step=0.1 min="1" max="20"><br>
		COP chillers<input type="number" name="COP_chillers" value="6" step=0.1 min="1" max="20"><br>
		
		Investment costs heat pump <input type="number" name="inv_var_hp_bldgs" value="800" step=1 min="50"> EUR/kW<br>
		Investment costs chiller <input type="number" name="inv_var_cc_bldgs" value="600" step=1 min="50"> EUR/kW<br>
		</div><br>
		<input type="checkbox" name="use_eh_in_bldgs" value="True">Use electric heaters in buildings<br>
		<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#expand_EH_bldgs">More...</button>
		<div id="expand_EH_bldgs" class="collapse">
		Thermal efficiency of electric heater<input type="number" name="eta_th_eh_bldg" value="0.98" step=0.01 min="0.5" max="1"><br>
		Investment costs electric heater<input type="number" name="inv_var_eh_bldgs" value="80" step=1 min="5"> EUR/kW<br>
		</div><br>
		<input type="checkbox" name="use_boi_in_bldgs" value="True">Use gas boilers in buildings<br>
		<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#expand_BOI_bldgs">More...</button>
		<div id="expand_BOI_bldgs" class="collapse">
		Thermal efficiency of gas boiler<input type="number" name="eta_th_boi_bldg" value="0.95" step=0.01 min="0.5" max="1"><br><br>
		Investment costs gas boiler<input type="number" name="inv_var_boi_bldgs" value="250" step=1 min="50"> EUR/kW<br>
		</div>
		<br>
      </div>
      <div class="col-sm-3"  style="border:1px solid #ccc">
        <h4>Network parameter</h4>
		Network length <input type="number" name="network_length" value="6.3" step=0.1 min="0" max="10"> km<br>
		<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#expand_network_temp">More...</button>
		<div id="expand_network_temp" class="collapse">
		Network temperature (hot pipe)<input type="number" name="network_temp_hot" value="25" step=1 min="0" max="50"> °C<br>
        Network temperature (cold pipe)<input type="number" name="network_temp_cold" value="20" step=1 min="0" max="50"> °C<br>
        </div>
      </div>
      <div class="col-sm-3" style="border:1px solid #ccc">
		<input type="checkbox" name="feasible_waste_heat" value="True" checked> <h4 style="display: inline;">Waste heat</h4><br>
		Waste heat temperature <input type="number" name="waste_heat_temp" value="50" step=1 min="0" max="999"> °C<br>
		Available heating power <input type="number" name="waste_heat_power" value="8750" step=1 min="0"> kW<br>
		Heat price <input type="number" name="price_waste_heat" value="0.00" step=0.001 min="0"> EUR/kWh<br>
		
		<input type="checkbox" name="feasible_waste_cold" value="True" checked> <h4 style="display: inline;">Waste cooling power</h4><br>
		Waste cooling temperature <input type="number" name="waste_cold_temp" value="5" step=1 min="0" max="999"> °C<br>
		Available thermal power <input type="number" name="waste_cooling_power" value="8750" step=1 min="0"> kW<br>
		Cooling power price <input type="number" name="price_waste_cold" value="0.00" step=0.001 min="0"> EUR/kWh<br>
      </div>
	  <div class="col-sm-3" style="border:1px solid #ccc">
		<input type="checkbox" name="feasible_PV" value="True"> <h4 style="display: inline;">Photovoltaic</h4><br>
		Available roof area <input type="number" name="PV_max_area" value="1000" step=10 min="0"> m2<br>
		<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#expand_PV">More...</button>
		<div id="expand_PV" class="collapse">
		Investment <input type="number" name="PV_inv_var" value="900" step=1000 min="0"> EUR/kW_peak<br>
		Efficiency <input type="number" name="PV_eta" value="0.18" step=0.01 min="0" max="0.5"><br>
		Life time <input type="number" name="PV_life_time" value="20" step=1 min="5" max="80"> a<br>
		Cost operation & maintenance <input type="number" name="PV_cost_om" value="0.02" step=0.005 min="0" max="0.2"> %/Inv<br><br>
		Minimal PV area<input type="number" name="PV_min_area" value="0" step=10 min="0"> m2<br>
		</div>
      </div>
    </div>
  </div>
  <br>
  <h4>Balancing unit</h4>
  <div class="container-fluid">
    <div class="row">
	  <div class="col-sm-3" style="border:1px solid #ccc">
        <input type="checkbox" name="feasible_BOI" value="True"> <h4 style="display: inline;">Boiler (gas-fired) </h4><br>
        <button type="button" class="btn btn-info" data-toggle="collapse" data-target="#expand_BOI">More...</button>
		<div id="expand_BOI" class="collapse">
		Minimal capacity<input type="number" name="BOI_min_cap" value="0" step=1 min="0"> kW<br>
		Maximal capacity<input type="number" name="BOI_max_cap" value="100000" step=1 min="0"> kW<br>
		Investment <input type="number" name="BOI_inv_var" value="150" step=1000 min="0"> EUR/kW_th<br>
		Thermal efficiency <input type="number" name="BOI_eta_th" value="0.95" step=0.01 min="0.5" max="1"><br>
		Life time <input type="number" name="BOI_life_time" value="30" step=1 min="5" max="80"> a<br>
		Cost operation & maintenance <input type="number" name="BOI_cost_om" value="0.01" step=0.005 min="0" max="0.2"> %/Inv<br>
		</div>
      </div>
      <div class="col-sm-3" style="border:1px solid #ccc">
        <input type="checkbox" name="feasible_CHP" value="True"> <h4 style="display: inline;">CHP (gas-fired) </h4><br>
		<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#expand_CHP">More...</button>
		<div id="expand_CHP" class="collapse">
		Minimal capacity<input type="number" name="CHP_min_cap" value="0" step=1 min="0"> kW<br>
		Maximal capacity<input type="number" name="CHP_max_cap" value="100000" step=1 min="0"> kW<br>
		Investment <input type="number" name="CHP_inv_var" value="1000" step=1000 min="0"> EUR/kW_el<br>
		Electrical efficiency <input type="number" name="CHP_eta_el" value="0.35" step=0.01 min="0.1" max="0.7"><br>
		Thermal efficiency <input type="number" name="CHP_eta_th" value="0.5" step=0.01 min="0.1" max="0.9"><br>
		Life time <input type="number" name="CHP_life_time" value="30" step=1 min="5" max="80"> a<br>
		Cost operation & maintenance <input type="number" name="CHP_cost_om" value="0.05" step=0.005 min="0" max="0.2"> %/Inv<br>
		
		</div>
      </div>
      <div class="col-sm-3" style="border:1px solid #ccc">
        <input type="checkbox" name="feasible_EH" value="True"> <h4 style="display: inline;">Electric heater</h4><br>
		<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#expand_EH">More...</button>
		<div id="expand_EH" class="collapse">
		Minimal capacity<input type="number" name="EH_min_cap" value="0" step=1 min="0"> kW<br>
		Maximal capacity<input type="number" name="EH_max_cap" value="10000" step=1 min="0"> kW<br>
		Investment <input type="number" name="EH_inv_var" value="78" step=1000 min="0"> EUR/kW_th<br>
		Thermal efficiency <input type="number" name="EH_eta_th" value="0.98" step=0.01 min="0.1" max="0.98"><br>
		Life time <input type="number" name="EH_life_time" value="20" step=1 min="5" max="80"> a<br>
		Cost operation & maintenance <input type="number" name="EH_cost_om" value="0.01" step=0.005 min="0" max="0.2"> %/Inv<br>
		</div>
      </div>
	  <div class="col-sm-3" style="border:1px solid #ccc">
		<input type="checkbox" name="feasible_GSHP" value="True"> <h4 style="display: inline;">Ground source heat pump</h4><br>
		<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#expand_GSHP">More...</button>
		<div id="expand_GSHP" class="collapse">
		Minimal capacity<input type="number" name="GSHP_min_cap" value="0" step=1 min="0"> kW<br>
		Maximal capacity<input type="number" name="GSHP_max_cap" value="100000" step=1 min="0"> kW<br>
		Investment <input type="number" name="GSHP_inv_var" value="900" step=1000 min="0"> EUR/kW_th<br>
		COP <input type="number" name="GSHP_COP" value="5" step=0.1 min="1" max="10"><br>
		Life time <input type="number" name="GSHP_life_time" value="20" step=1 min="5" max="80"> a<br>
		Cost operation & maintenance <input type="number" name="GSHP_cost_om" value="0.03" step=0.005 min="0" max="0.2"> %/Inv<br>
		</div>
      </div>
    </div>
	<div class="row">
	  <div class="col-sm-3" style="border:1px solid #ccc">
        <input type="checkbox" name="feasible_CC" value="True" checked> <h4 style="display: inline;">Compression chiller</h4><br>
		<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#expand_CC">More...</button>
		<div id="expand_CC" class="collapse">
		Minimal capacity<input type="number" name="CC_min_cap" value="0" step=1 min="0"> kW<br>
		Maximal capacity<input type="number" name="CC_max_cap" value="100000" step=1 min="0"> kW<br>
		Investment <input type="number" name="CC_inv_var" value="600" step=1000 min="0"> EUR/kW_th<br>
		COP <input type="number" name="CC_COP" value="9" step=0.1 min="1" max="10"><br>
		Life time <input type="number" name="CC_life_time" value="20" step=1 min="5" max="80"> a<br>
		Cost operation & maintenance <input type="number" name="CC_cost_om" value="0.03" step=0.005 min="0" max="0.2"> %/Inv<br>
		</div>
      </div>
      <div class="col-sm-3" style="border:1px solid #ccc">
        <input type="checkbox" name="feasible_AC" value="True"> <h4 style="display: inline;">Absorption chiller</h4><br>
		<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#expand_AC">More...</button>
		<div id="expand_AC" class="collapse">
		Minimal capacity<input type="number" name="AC_min_cap" value="0" step=1 min="0"> kW<br>
		Maximal capacity<input type="number" name="AC_max_cap" value="100000" step=1 min="0"> kW<br>
		Investment <input type="number" name="AC_inv_var" value="750" step=1000 min="0"> EUR/kW_th<br>
		Thermal efficiency <input type="number" name="AC_eta_th" value="0.6" step=0.05 min="0.2" max="1.5"><br>
		Life time <input type="number" name="AC_life_time" value="20" step=1 min="5" max="80"> a<br>
		Cost operation & maintenance <input type="number" name="AC_cost_om" value="0.05" step=0.005 min="0" max="0.2"> %/Inv<br>
		</div>
      </div>
      <div class="col-sm-3" style="border:1px solid #ccc">
		
      </div>
	  <div class="col-sm-3" style="border:1px solid #ccc">

      </div>
    </div>
	<div class="row">
	  <div class="col-sm-3" style="border:1px solid #ccc">
	  <input type="checkbox" name="feasible_TES" value="True"> <h4 style="display: inline;">Heat storage</h4><br>
	  <button type="button" class="btn btn-info" data-toggle="collapse" data-target="#expand_TES">More...</button>
		<div id="expand_TES" class="collapse">
		Investment <input type="number" name="TES_inv_var" value="15" step=1000 min="0"> EUR/kWh<br>
		Storage losses <input type="number" name="TES_sto_loss" value="0.01" step=0.001 min="0" max="0.5">%/h<br>
		Life time <input type="number" name="TES_life_time" value="20" step=1 min="5" max="80"> a<br>
		Cost operation & maintenance <input type="number" name="TES_cost_om" value="0.01" step=0.005 min="0" max="0.2"> %/Inv<br>
		Minimal capacity<input type="number" name="TES_min_cap" value="0" step=1 min="0"> kWh<br>
		Maximum capacity <input type="number" name="TES_max_cap" value="10000" step=1000 min="0" max="10000000"> kWh<br>
		</div>
	  </div>
	  <div class="col-sm-3" style="border:1px solid #ccc">
	  <input type="checkbox" name="feasible_CTES" value="True"> <h4 style="display: inline;">Cold storage</h4><br>
	  <button type="button" class="btn btn-info" data-toggle="collapse" data-target="#expand_CTES">More...</button>
		<div id="expand_CTES" class="collapse">
		Investment <input type="number" name="CTES_inv_var" value="45" step=1000 min="0"> EUR/kWh<br>
		Storage losses <input type="number" name="CTES_sto_loss" value="0.01" step=0.001 min="0" max="0.5">%/h<br>
		Life time <input type="number" name="CTES_life_time" value="20" step=1 min="5" max="80"> a<br>
		Cost operation & maintenance <input type="number" name="CTES_cost_om" value="0.01" step=0.005 min="0" max="0.2"> %/Inv<br>
		Minimal capacity<input type="number" name="CTES_min_cap" value="0" step=1 min="0"> kWh<br>
		Maximum capacity <input type="number" name="CTES_max_cap" value="10000" step=1000 min="0" max="10000000"> kWh<br>
		</div>
	  </div>
	  <div class="col-sm-3" style="border:1px solid #ccc">
	  <input type="checkbox" name="feasible_BAT" value="True"> <h4 style="display: inline;">Battery</h4><br>
	  <button type="button" class="btn btn-info" data-toggle="collapse" data-target="#expand_BAT">More...</button>
		<div id="expand_BAT" class="collapse">
		Investment <input type="number" name="BAT_inv_var" value="1000" step=1000 min="0"> EUR/kWh<br>
		Charging efficiency <input type="number" name="BAT_eta_ch" value="0.975" step=0.001 min="0.6" max="1"><br>
		Life time <input type="number" name="BAT_life_time" value="20" step=1 min="5" max="80"> a<br>
		Cost operation & maintenance <input type="number" name="BAT_cost_om" value="0.01" step=0.005 min="0" max="0.2"> %/Inv<br>
		Minimal capacity<input type="number" name="BAT_min_cap" value="0" step=1 min="0"> kWh<br>
		Maximum capacity <input type="number" name="BAT_max_cap" value="10000" step=1000 min="0" max="10000000"> kWh<br>
		</div>
	  </div>
	  <div class="col-sm-3" style="border:1px solid #ccc">
	  </div>
    </div>
	<div class="row">
	  <div class="col-sm-3" style="border:1px solid #ccc">
	  <input type="checkbox" name="feasible_DH" value="True" checked> <h4 style="display: inline;">Connection to district heating network</h4><br>
	  <button type="button" class="btn btn-info" data-toggle="collapse" data-target="#expand_DH">More...</button>
		<div id="expand_DH" class="collapse">
		Price district heating <input type="number" step="0.001" name="price_DH" value="0.07"> EUR / kWh<br><br>
		</div>
	  <input type="checkbox" name="feasible_DC" value="True"> <h4 style="display: inline;">Connection to district cooling network</h4><br>
	  <button type="button" class="btn btn-info" data-toggle="collapse" data-target="#expand_DC">More...</button>
		<div id="expand_DC" class="collapse">
		Price district cooling <input type="number" step="0.001" name="price_DC" value="0.08"> EUR / kWh
	  </div>
	  </div>
	  <div class="col-sm-3" style="border:1px solid #ccc">
	  </div>
	  <div class="col-sm-3" style="border:1px solid #ccc">
	  </div>
	  <div class="col-sm-3" style="border:1px solid #ccc">
	  </div>
    </div>
  </div>
</div>

<div id="Economic_params" class="tabcontent" style="background-color:#ffdddd">
  <h3>Economic parameters</h3>
    <div class="container-fluid">
    <div class="row">
	  <div class="col-sm-3" style="border:1px solid #ccc">
        <h4>General</h4>
        Interest rate: <input type="number" step="1" style="width: 150px;" name="interest_rate" value="5" min="0" max="20"> %<br><br>
		Project lifetime: <input type="number" step="1" width="4" name="observation_time" value="25" min="3" max="80"> years<br><br>
		Other investment costs: <input type="number" step="1000" min="0" width="4" name="other_invest_costs" value="0"> EUR<br>
		Other annual costs: <input type="number" step="1000" min="0" width="4" name="other_ann_costs" value="0"> EUR/a<br>
      </div>
      <div class="col-sm-3"  style="border:1px solid #ccc">
        <h4>Energy costs</h4>
		Price natural gas: <input type="number" step="0.001" name="price_gas" value="0.027"> EUR / kWh<br><br>
		Price electricity: <input type="number" step="0.001" name="price_el" value="0.145"> EUR / kWh<br><br>
		Electricity feed-in allowed? <input type="checkbox" name="feasible_feed_in" value="True"><br><br>
		Tariff electricity feed-in: <input type="number" step="0.001" name="revenue_feed_in" value="0.1"> EUR / kWh<br><br>
      </div>
      <div class="col-sm-3" style="border:1px solid #ccc">
        <h4>Ecological impact</h4>
        CO2 emissions (electricity mix): <input type="number" step="0.001" name="grid_CO2_emission" value="0.490" min="0.001" max="2"> kg / kWh<br><br>
		CO2 emissions (natural gas): <input type="number" step="0.001" name="gas_CO2_emission" value="0.25" min="0.001" max="0.5"> kg / kWh
      </div>
	  <div class="col-sm-3" style="border:1px solid #ccc">
        <h4>Pipe installation</h4>
		Costs earth work <input type="number" step="1" width="4" name="costs_earth_work" value="250"> EUR / m<br><br>
        Costs pipes: <input type="number" step="1" width="4" name="costs_pipe" value="50"> EUR / m
      </div>
    </div>
  </div>
</div>

{% if processing_successful %}
<div id="results_overview" class="tabcontent" style="background-color:#ccffcc">
	<h3>Summary</h3>
	<h4>Total annualized costs: {{ main_results.total_costs }} EUR</h4>
	<h4>Heating / cooling costs: {{ main_results.spec_total_costs }} EUR/kWh</h4>
	<h4><strong>Recommendation: </strong> {{ main_results.report_text }}</h4>
	<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#cost_details">More details...</button>
	<div id="cost_details" class="collapse">
	<table style="width:30%; text-align: right">
      <tr><th><h4>Investment costs:</h4></th><th></th><th></th></tr>
      <tr><td>Equipment in buildings</td><td>{{ res_intra_bldg_bal.ann_total_bldg_equip_cost }} EUR/a</td><td>{{ res_intra_bldg_bal.total_bldg_equip_cost }} EUR</td></tr>
      <tr><td>Equipment in balancing unit</td><td>{{ res_bal_unit.ann_total_bu_equip_cost }} EUR/a</td><td>{{ res_bal_unit.total_bu_equip_cost }} EUR</td></tr>
      <tr><td>Pipe installation</td><td>{{ main_results.ann_piping_cost }} EUR/a</td><td>{{ main_results.piping_cost }} EUR</td></tr>
      <tr><td>Other investment costs</td><td>{{ main_results.ann_other_invest_costs }} EUR/a</td><td>{{ main_results.other_invest_costs }} EUR</td></tr>
      <tr><th><h4>Operation costs:</h4></th><th></th><th></th></tr>
      <tr><td>Gas costs</td><td>{{ main_results.total_gas_costs }} EUR/a</td><td></td></tr>
      <tr><td>Electricity costs</td><td>{{ main_results.total_power_from_grid_costs }} EUR/a</td><td></td></tr>
      <tr><td>Feed-in costs</td><td>-{{ main_results.total_power_to_grid_revenue }} EUR/a</td><td></td></tr>
      <tr><td>District heating</td><td>{{ main_results.total_from_DH_costs }} EUR/a</td><td></td></tr>
      <tr><td>District cooling</td><td>{{ main_results.total_from_DC_costs }} EUR/a</td><td></td></tr>
      <tr><td>Waste heat</td><td>{{ main_results.total_waste_heat_costs }} EUR/a</td><td></td></tr>
      <tr><td>Waste cooling power</td><td>{{ main_results.total_waste_cold_costs }} EUR/a</td><td></td></tr>
      <tr><td>Operation maintenance costs</td><td>{{ res_bal_unit.total_bu_om_cost }} EUR/a</td><td></td></tr>
      <tr><td>Other annual costs</td><td>{{ main_results.other_ann_costs }} EUR/a</td><td></td></tr> 
    </table>
	<!-- SUMME KOSTEN: {{ main_results.CHECK_SUM }} 
	<p>Total annualized costs (BU): {{ res_bal_unit.obj.tac }} EUR</p>-->
	</div>
	
	<h4>End energy demand</h4>
	<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#end_energy_details">Show details...</button>
	<div id="end_energy_details" class="collapse">
	<table style="width:350px; text-align: right">
      <tr><td>Gas demand</td><td>{{ main_results.total_gas_demand }} kWh</td><td></td></tr>
      <tr><td>Power from grid</td><td>{{ main_results.total_power_from_grid }} kWh</td><td></td></tr>
      <tr><td>Power to grid</td><td>{{ main_results.total_power_to_grid }} kWh</td><td></td></tr>
      <tr><td>PV power</td><td>{{ res_bal_unit.total_PV_power }} kWh</td><td></td></tr>
      <tr><td>District heating</td><td>{{ res_bal_unit.total_from_DH }} kWh</td><td></td></tr>
      <tr><td>District cooling</td><td>{{ res_bal_unit.total_from_DC }} kWh</td><td></td></tr>
      <tr><td>Waste heat</td><td>{{ res_bal_unit.total_from_WASTE }} kWh</td><td></td></tr>
      <tr><td>Waste cooling power</td><td>{{ res_bal_unit.total_from_WASTE_cold }} kWh</td><td></td></tr>
    </table>
	</div>
	
	<br><h4>Ecological impact</h4>
	<table style="width:350px; text-align: right">
      <tr><td>CO2 emissions</td><td>{{ main_results.CO2 }} kg/a</td><td></td></tr>
      <tr><td>Primary energy factor</td><td>{{ main_results.primary_energy_factor }}</td><td></td></tr>
    </table>

    <br><h4>Demand analysis</h4>
    
    <table style="width:550px; text-align: right">
      <tr><td></td><td>Buildings</td><td>Met by balancing unit</td></tr>
      <tr><td>Heat demand</td><td>{{ res_bldg_bal.total_heat_demand }} kWh</td><td>{{ res_bldg_bal.sum_residual_heat }} kWh</td></tr>
      <tr><td>Cold demand</td><td>{{ res_bldg_bal.total_cool_demand }} kWh</td><td>{{ res_bldg_bal.sum_residual_cool }} kWh</td></tr>
    </table>
    <p>Demand overlap coefficient: <b>{{ res_intra_bldg_bal.DOC_dem }}</b></p>
    <p>Balanced in buildings: <b>{{ res_intra_bldg_bal.DOC_int_ges }}</b></p>
    <p>Balanced between buildings: <b>{{ res_bldg_bal.DOC_netw }}</b></p>
    <p>Diversity index: <b>{{ res_intra_bldg_bal.div_index }}</b>).</p>
	<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#show_bldg_demands">Show plot</button>
	<div id="show_bldg_demands" class="collapse">
	<img src="{% static 'Total_demands.png' %}" alt="heat_cool_demands" style="width:400px;">
	<p>Residual heat and cold demands covered by balancing unit (plot):</p>
	<img src="{% static 'Total_residual_demands.png' %}" alt="residual_heat_cool_demands" style="width:400px;">
	</div>
	
    <br><h3>Buildings</h3>
    <button type="button" class="btn btn-info" data-toggle="collapse" data-target="#res_bldgs">More...</button>
	<div id="res_bldgs" class="collapse">
	<table style="width:30%; text-align: right">
      <tr><th><b>Technology</b></th><th><b>Capacity</b></th><th><b>Power / gas demand</b></th><th><b>Mean COP</b></th></tr>
      <tr><td>Heat pump</td><td>{{ res_intra_bldg_bal.total_bldg_hp_cap }} kW</td><td>{{ res_bldg_bal.sum_power_dem_HP }} kWh</td><td>{{ res_intra_bldg_bal.mean_COP_HP }}</td></tr>
      <tr><td>Chiller</td><td>{{ res_intra_bldg_bal.total_bldg_cc_cap }} kW</td><td>{{ res_bldg_bal.sum_power_dem_CC }} kWh</td><td>{{ res_intra_bldg_bal.mean_COP_CC }}</td></tr>
      <tr><td>Electric heater</td><td>{{ res_intra_bldg_bal.total_bldg_eh_cap }} kW</td><td>{{ res_bldg_bal.sum_power_dem_EH }} kWh</td></tr>
      <tr><td>Gas boiler</td><td>{{ res_intra_bldg_bal.total_bldg_boi_cap }} kW</td><td>{{ res_intra_bldg_bal.gas_demand_bldgs }} kWh</td></tr>
      <tr><td>PV area</td><td>{{ res_bal_unit.total_PV_area }} m2</td><td></td></tr>
    </table>
    </div>

	<br><h3>Balancing unit</h3>
	
	<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#res_inst_cap_BU">Show sizing details...</button>
	<div id="res_inst_cap_BU" class="collapse">
	<h4>Installed capacities:</h4>
	
	<table style="width:350px; text-align: right">
      <tr><td>Boiler</td><td>{{ res_bal_unit.cap.BOI }} kW</td><td></td></tr>
      <tr><td>CHP</td><td>{{ res_bal_unit.cap.CHP }} kW</td><td></td></tr>
      <tr><td>Electric heater</td><td>{{ res_bal_unit.cap.EH }} kW</td><td></td></tr>
      <tr><td>Ground source heat pump</td><td>{{ res_bal_unit.cap.GSHP }} kW</td><td></td></tr>
      <tr><td>Compression chiller</td><td>{{ res_bal_unit.cap.CC }} kW</td><td></td></tr>
      <tr><td>Absorption chiller</td><td>{{ res_bal_unit.cap.AC }} kW</td><td></td></tr>
      <tr><td>Heat storage</td><td>{{ res_bal_unit.cap.TES }} kWh</td><td></td></tr>
      <tr><td>Cold storage</td><td>{{ res_bal_unit.cap.CTES }} kWh</td><td></td></tr>
      <tr><td>Battery</td><td>{{ res_bal_unit.cap.BAT }} kWh</td><td></td></tr>
      <tr><td>Connection to district heating</td><td>{{ res_bal_unit.cap.from_DH }} kW</td><td></td></tr>
      <tr><td>Connection to district cooling</td><td>{{ res_bal_unit.cap.from_DC }} kW</td><td></td></tr>      
    </table>
	</div>
</div>

<div id="results_buildings" class="tabcontent" style="background-color:#ccffcc">
	<h3>Building overview</h3><br>
	{% for key, value in res_nodes.items %} 
    	<div style="border:1px solid #ccc">
    	<h4>Building {{ value.id}}</h4>
    	<b>Equipment:</b><br>
    	Heat pump: {{ value.hp_capacity }} kW ({{ value.hp_costs }} EUR)<br>
    	Electric heater: {{ value.eh_capacity }} kW ({{ value.eh_costs }} EUR)<br>
    	Gas boiler: {{ value.boi_capacity }} kW ({{ value.boi_costs }} EUR)<br>
    	Chiller capacity {{value.cc_capacity }} kW ({{ value.cc_costs }} EUR)<br><br>    
    	<b>Performance:</b><br>
    	Total heat demand: {{ value.total_heat }} kWh<br>
    	Total cold demand: {{ value.total_cool}} kWh<br>
    	Electricity demand: {{ value.total_power_dem }} kWh<br>
    	Gas demand: {{ value.total_gas_dem }} kWh<br>
    	Share of internally balanced energy: {{ value.DOC_int }}<br><br>
    	</div>
    {% endfor %}
    
</div>

<div id="results_subsidies" class="tabcontent" style="background-color:#ccffcc">
	<h3>Check for subsidies</h3>
	<h4>Total estimated subsidies: {{ res_subsidies.total }} EUR (annualized: {{ res_subsidies.ann_total }} EUR/a)</h4>
	Capital recovery factor: {{ main_results.CRF }}
	
	<br><h4>Overview power generation:</h4>
	<b>PV feed-in: {{ res_subsidies.total_power_PV_grid }} kWh/a</b><br>
	<b>PV self-consumption: {{ res_subsidies.total_power_PV_self }} kWh/a</b><br>
	<b>CHP feed-in: {{ res_subsidies.total_power_CHP_grid }} kWh/a</b><br>
	<b>CHP self-consumption: {{ res_subsidies.total_power_CHP_self }} kWh/a</b><br>
	
	<!-- PV -->	
	<br><br><h3>EEG-Subsidies</h3>
	<h4>Photovoltaics (non-residential buildings, smaller than 100 kW):</h4> 
	<b>Subsidy: </b>Feed-in: 0,0793 EUR/kWh, Self-consumption: 0,02652 EUR/kWh<br>
	<b>In this scenario: {{ res_subsidies.EEG_PV }} EUR/a</b>
	
	<!-- CHP -->		
	<br><br><h3><a href="http://www.bafa.de/DE/Energie/Energieeffizienz/Kraft_Waerme_Kopplung/kraft_waerme_kopplung_node.html">KWKG</a>-Subsidies</h3>
	<h4>CHP units:</h4>
	<b>Subsidy: </b>Feed-in: 0,044-0,08 EUR/kWh, Self-consumption: 0,015-0,04 EUR/kWh (depending on capacity)<br>
	<b>In this scenario: {{ res_subsidies.KWKG_CHP }} EUR</b>
	
	<!-- THERMAL ENERGY STORAGE -->	
	<br><br><h4>Thermal energy storages:</h4>
	<b>Preconditions: </b>50 % of heat must be generated by CHP or regenerative/waste heat (at least 25 % from CHP)<br>
    <b>Subsidy: </b>250 EUR/m3 (maximum: 30 % of investment, or 10 million EUR)<br>
	<b>In this scenario: {{ res_subsidies.KWKG_TES }} EUR</b><br>
	<a href="http://www.bafa.de/DE/Energie/Energieeffizienz/Kraft_Waerme_Kopplung/Waerme_Kaeltespeicher/Speichervolumen_ueber_50/speichervolumen_ueber_50_node.html">Check details</a>
	
	<!-- DISTRICT HEATING NETWORK -->	
	<br><br><h4>District heating networks:</h4>
	<b>Preconditions: </b>75 % of the heat must be generated by CHP or 50 % from CHP and regenerative/waste heat<br>
    <b>Subsidy: </b>100 EUR/m of supply pipe length (maximum: 40 % of investment or 20 million EUR)<br>
	<b>In this scenario: {{ res_subsidies.network_subsidy }} EUR</b><br>
    <a href="http://www.bafa.de/DE/Energie/Energieeffizienz/Kraft_Waerme_Kopplung/Waerme_Kaeltenetze/waerme_kaeltenetze_node.html">Check details</a>
	
	<!-- HEAT PUMPS -->
	<h3><a href="http://www.bafa.de">BAFA</a>-Subsidies</h3>
    <h4>Heat pumps (smaller than 100 kW)</h4>
    <b>Subsidy: </b>100 EUR/kW<br>
    <b>In this scenario: {{ res_subsidies.BAFA_HP }} EUR</b> (for in total {{ BAFA_number_HP }} heat pumps)<br>
    <a href="https://www.carmen-ev.de/infothek/foerderung/erneuerbare-energien/556-bafa-foerderung-von-waermepumpen">Check details</a>
    
    <h4>Further subsidies:</h4>    
    Free cooler: <a href="https://www.carmen-ev.de/infothek/foerderung/erneuerbare-energien/1074-bafa-foerderung-von-sorptionskaelteanlagen">Check details</a><br>
    Cold storages: <a href="https://www.carmen-ev.de/infothek/foerderung/erneuerbare-energien/1074-bafa-foerderung-von-sorptionskaelteanlagen">Check details</a><br>
    Energy efficient equipment: <a href="https://www.carmen-ev.de/infothek/foerderung/erneuerbare-energien/3045-kfw-energieeffizienzprogramm-abwaerme-295">Check details</a><br>
    PV-Battery-system: <a href="https://www.carmen-ev.de/infothek/foerderung/erneuerbare-energien/572-kfw-erneuerbare-energien-speicher">Check details</a><br>
    Heat pumps: <a href="https://www.carmen-ev.de/infothek/foerderung/erneuerbare-energien/561-kfw-foerderung-von-grossen-effizienten-waermepumpen-ab-100-kw">Check details</a><br>
    
    
</div>
{% endif %}



</form>

<script>

function change_default_settings(val) {
	if (val == "sweden") {
	alert("Changing settings to default settings for Sweden.")
	<!-- change weather data file -->
	<!-- change technical and economical parameters -->
	}
	if (val == "germany") {
	alert("Changing settings to default settings for Germany.")
	<!-- change weather data file -->
	<!-- change technical and economical parameters -->
	}
}

var number_buildings = "global";
number_buildings = 1;

function addBuilding() {
	number_buildings = number_buildings + 1
	file_nr = number_buildings - 1
	
	var add_bldg_code = '<h4>Building ' + (file_nr+1) + '</h4>Heated/cooled floor area<input type="number" name="bldg_' + file_nr + '_heated_area" value="1000" step=10 min="50"> m2<br>Specific heating demand <input type="number" name="bldg_' + file_nr + '_spec_heat_dem" value="110" step=1 min="0"> kWh/m2<br>Specific cooling demand <input type="number" name="bldg_' + file_nr + '_spec_cool_dem" value="30" step=1 min="0"> kWh/m2<br>Building type<select name="bldg_' + file_nr + '_type" selected="residential"><option value="residential">Residential</option><option value="office">Office</option></select><br><br><button type="button" class="btn btn-info" data-toggle="collapse" data-target="#upload_time_series_' + file_nr + '">Upload time series</button><div id="upload_time_series_' + file_nr + '" class="collapse">Heating demand (in kW) <input type="file" name="bldg_' + file_nr + '_file_heat_dem">Cooling demand (in kW) <input type="file" name="bldg_' + file_nr + '_file_cool_dem"><br><br></div>'
	
    document.getElementById("building_div").innerHTML += add_bldg_code;
}

function submitTheForm() {

	<!-- file_heat_dem0 = document.forms["theForm"]["bldg_0_file_heat_dem"].value; -->
	<!-- file_cool_dem0 = document.forms["theForm"]["bldg_0_file_cool_dem"].value; -->
	
	<!-- if (file_heat_dem0.length === 0) { -->
		<!-- document.getElementById("error_msg").innerHTML = "Error: No heat demand file selected."; -->
		<!-- } -->
	<!-- else if (file_cool_dem0.length === 0) { -->
		<!-- document.getElementById("error_msg").innerHTML = "Error: No cooling demand file selected."; -->
		<!-- } -->
	
	<!-- else {	 -->
	document.getElementById("error_msg").innerHTML = "Processing...";
	document.theForm.submit();
	<!-- } -->
	}

function openTab(evt, tabName) {
    var i, tabcontent, tablinks;
    tabcontent = document.getElementsByClassName("tabcontent");
    for (i = 0; i < tabcontent.length; i++) {
        tabcontent[i].style.display = "none";
    }
    tablinks = document.getElementsByClassName("tablinks");
    for (i = 0; i < tablinks.length; i++) {
        tablinks[i].className = tablinks[i].className.replace(" active", "");
    }
    document.getElementById(tabName).style.display = "block";
    evt.currentTarget.className += " active";
}

// Get the element with id="defaultOpen" and click on it
document.getElementById("defaultOpen").click(); 
{% if processing_successful %}
document.getElementById("defaultOpenResult").click(); 
{% endif %}
</script>



<!---
<script src="http://d3js.org/d3.v3.min.js"></script>
<script src="sankey.js"></script>

<script>
	
var units = "Widgets";

var margin = {top: 10, right: 10, bottom: 10, left: 10},
    width = 700 - margin.left - margin.right,
    height = 300 - margin.top - margin.bottom;

var formatNumber = d3.format(",.0f"),    // zero decimal places
    format = function(d) { return formatNumber(d) + " " + units; },
    color = d3.scale.category20();

// append the svg canvas to the page
var svg = d3.select("#chart").append("svg")
    .attr("width", width + margin.left + margin.right)
    .attr("height", height + margin.top + margin.bottom)
  .append("g")
    .attr("transform", 
          "translate(" + margin.left + "," + margin.top + ")");

// Set the sankey diagram properties
var sankey = d3.sankey()
    .nodeWidth(36)
    .nodePadding(40)
    .size([width, height]);

var path = sankey.link();

// load the data
d3.json("{% static 'myapp/sankey_data/sankey-formatted.json' %}", function(error, graph) {

  sankey
      .nodes(graph.nodes)
      .links(graph.links)
      .layout(32);

// add in the links
  var link = svg.append("g").selectAll(".link")
      .data(graph.links)
    .enter().append("path")
      .attr("class", "link")
      .attr("d", path)
      .style("stroke-width", function(d) { return Math.max(1, d.dy); })
      .sort(function(a, b) { return b.dy - a.dy; });

// add the link titles
  link.append("title")
        .text(function(d) {
    		return d.source.name + " → " + 
                d.target.name + "\n" + format(d.value); });

// add in the nodes
  var node = svg.append("g").selectAll(".node")
      .data(graph.nodes)
    .enter().append("g")
      .attr("class", "node")
      .attr("transform", function(d) { 
		  return "translate(" + d.x + "," + d.y + ")"; })
    .call(d3.behavior.drag()
      .origin(function(d) { return d; })
      .on("dragstart", function() { 
		  this.parentNode.appendChild(this); })
      .on("drag", dragmove));

// add the rectangles for the nodes
  node.append("rect")
      .attr("height", function(d) { return d.dy; })
      .attr("width", sankey.nodeWidth())
      .style("fill", function(d) { 
		  return d.color = color(d.name.replace(/ .*/, "")); })
      .style("stroke", function(d) { 
		  return d3.rgb(d.color).darker(2); })
    .append("title")
      .text(function(d) { 
		  return d.name + "\n" + format(d.value); });

// add in the title for the nodes
  node.append("text")
      .attr("x", -6)
      .attr("y", function(d) { return d.dy / 2; })
      .attr("dy", ".35em")
      .attr("text-anchor", "end")
      .attr("transform", null)
      .text(function(d) { return d.name; })
    .filter(function(d) { return d.x < width / 2; })
      .attr("x", 6 + sankey.nodeWidth())
      .attr("text-anchor", "start");

// the function for moving the nodes
  function dragmove(d) {
    d3.select(this).attr("transform", 
        "translate(" + d.x + "," + (
                d.y = Math.max(0, Math.min(height - d.dy, d3.event.y))
            ) + ")");
    sankey.relayout();
    link.attr("d", path);
  }
});

</script>
--->